
/****************************************************************/
/*                                                              */
/*  Practica de Arquitectures Especialitzades                   */
/*                                                              */
/*  Execucio paral.lela de l'algorisme d'ordenacio de vectors   */
/*  basada en els estandards de MPI                             */
/*                                                              */
/*  Realitzada per:  Francisco Jose Aguilar Celdran             */
/*                   Sergio Blanco Cuaresma                     */
/****************************************************************/ 


#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include <mpi.h>

#define N 200000
#define TAM_BUFFER 50000

int valors[N];

int *fusio_subvectors_ordenats(int *vector_a, int *vector_b, int tam_a, int tam_b)
{
   int *ordenat;
   int fi_vectors = 0;
   int pos_a = 0;
   int pos_b = 0,i;
   int comptador = 0;
   //int menor_a, menor_b;

   ordenat = (int *) malloc(sizeof(int) * (tam_a + tam_b));
   while (!fi_vectors) {
      
      while ((pos_a < tam_a) && (vector_a[pos_a] <= vector_b[pos_b])) {
         ordenat[comptador] = vector_a[pos_a];
         comptador++;
         pos_a++;

      }
      while ((pos_b < tam_b) && (vector_b[pos_b] <= vector_a[pos_a])) {
         ordenat[comptador] = vector_b[pos_b];
         comptador++;
         pos_b++;

      }
      if (pos_a == tam_a) {
         while (pos_b < tam_b) {
            ordenat[comptador] = vector_b[pos_b];
            comptador++;
            pos_b++;

         }
      }
      else if (pos_b == tam_b) {
         while (pos_a < tam_a) {
            ordenat[comptador] = vector_a[pos_a];
            comptador++;
            pos_a++;

         }         
      }
      if (comptador == (tam_a + tam_b)) {
         fi_vectors = 1;
      }
   }
    for (i = 0; i < 9; i++){

      }
   return ordenat;
}

int *merge_sort(int **subvector, int num_processos, int *tam)
{
   int i, comptador;
   
   if (num_processos == 1) {
      return subvector[0];
   }
   else {
      comptador = 0;
      for (i = 0; i < num_processos; i += 2) {
         subvector[comptador] = fusio_subvectors_ordenats(&subvector[i][0],&subvector[i+1][0],tam[i],tam[i+1]);
         tam[comptador] = tam[i] + tam[i + 1];
         comptador++;
      }
      return merge_sort(&subvector[0],num_processos / 2,tam);
   }
}



int main(int num_args, char *args[])
{
   int i, j, min_index, minim;
   int rank_proces;
   int num_processos;
   int buffer_proces[N];
   int tam_particio;
   int tam, tag = 0;
   //int solapament;
   //int buffer_enviaments[TAM_BUFFER];
   double sum = 0;
   FILE *sal;
   MPI_Status *estat;
   int **subvector;
   int *tamanys, *resultat;
   int iteracions_totals;
   int iteracions_restants;
   int opcio_execucio;
   int index_actual;
   MPI_Request req;
   int a[5],b[4];
   int *c;
   
   
   // Inicialitzar MPI
   MPI_Init(&num_args,&args);
   
   // Obtenir el rank del proces actual
   MPI_Comm_rank(MPI_COMM_WORLD,&rank_proces);
   
   // Obtenir el numero total de processos
   MPI_Comm_size(MPI_COMM_WORLD,&num_processos);

   if (rank_proces == 0) {
      for(i = 0; i < N; i++) {
         valors[i]= rand();
      }
   }

   // Si hi ha dos o mes processos: execucio parallela de l'algorisme, mitjanant pas de missatges de MPI
   if (num_processos > 1) 
   {
      // En cas de no ser exacta la divisio de les N iteracions entre el numero de processos,
      // les iteracions que manquen s'afegiran al tamany de particio de l'ultim proces

      tam_particio = N / num_processos;
      iteracions_totals = tam_particio * num_processos;
      if (iteracions_totals < N) {
         iteracions_restants = N - iteracions_totals;
      }

      // Declaracio del buffer d'enviament local, per a comunicacio asincrona
      //MPI_Buffer_attach(buffer_enviaments,TAM_BUFFER);
      
      // Proces Host:  - Inicialitza aleatoriament la taula de valors
      //               - (NO CAL) Transmet els valors de l'area de solapament de cada proces, menys
      //                 el proces host i l'ultim proces kernel, amb comunicacio asincrona
      
      tamanys = (int *) malloc((num_processos) * sizeof(int));
      for (i = 0; i < num_processos - 1; i++) {
         tamanys[i] = tam_particio;
      }
      if (iteracions_restants > 0) {
         tamanys[num_processos - 1] = tam_particio + iteracions_restants;
      }
      else {
         tamanys[num_processos - 1] = tam_particio;
      }
      if (rank_proces == 0) {
         subvector = (int **) malloc((num_processos) * sizeof(int *));
         for (i = 0; i < num_processos; i++) {
            subvector[i] = (int *) malloc((tamanys[i]) * sizeof(int));
         }
         /*if (iteracions_restants > 0) {
            subvector[num_processos - 1] = (int *) malloc((tam_particio + iteracions_restants) * sizeof(int));
         }
         else {
            subvector[num_processos - 1] = (int *) malloc((tam_particio) * sizeof(int));
         }*/
         /* NO CAL TRACTAR CAP SOLAPAMENT
         for(i = 1; i < num_processos - 1; i++) {
            printf("enviant...(%d) ",i);fflush(stdout);
            MPI_Bsend(&valors[(tam_particio * (i + 1))],1,MPI_INT,i,tag,MPI_COMM_WORLD);
            printf("enviat...(%d) ",i);fflush(stdout);
         }
         //solapament = valors[tam_particio];
         */
      }         
      /* NO CAL TRACTAR CAP SOLAPAMENT
      // Els processos kernel reben el valor de la seva respectiva area de solapament
      if ((rank_proces != 0) && (rank_proces != num_processos - 1)) {
         printf("rebent...(%d) ",rank_proces);fflush(stdout);
         MPI_Recv(&solapament,1,MPI_INT,0,tag,MPI_COMM_WORLD,estat);
         printf("rebut...(%d) ",rank_proces);fflush(stdout);
      } */
      
      /* buffer_proces = (int *) malloc(N * sizeof(int)); */
      
   
    
      // Distribucio de les dades a parts iguals entre tots els processos
      // (Provar el rendiment comparant a fer-ho amb comunicacio sincrona no bloquejant
      // amb el que el proces Host iniciaria els seus calculs, provar doncs a donar mes part de calcul
      // al proces 0)
      
      opcio_execucio = 0;
      // Enviament dels subvectors a cada proces emprant operacio colectiva de difusio MPI_Scatter
      if (opcio_execucio == 0) {
         MPI_Scatter(valors,tamanys[rank_proces],MPI_INT,buffer_proces,tam_particio,MPI_INT,0,MPI_COMM_WORLD);
      }
      // Enviament dels subvectors emprant pas de missatges sincron
      else if (opcio_execucio == 1) {
         if (rank_proces == 0) {
            index_actual = tamanys[0];
            for (i = 1; i < num_processos; i++) {
               MPI_Ssend(&valors[index_actual],tamanys[i],MPI_INT,i,tag,MPI_COMM_WORLD);
               index_actual += tamanys[i];
            }
            //buffer_proces = valors;
         }
         else {
            MPI_Recv(&buffer_proces[0],tamanys[rank_proces],MPI_INT,0,tag,MPI_COMM_WORLD,estat);
         }
      }
      // Enviament dels subvectors emprant pas de missatges sincron no bloquejant
      // S'aprofita que el proces Host ja te el subvector, de forma que processara
      // un subvector major donat que inciara la ordenacio mentre s'estan enviant
      // els subvectors a cada proces.
      else if (opcio_execucio == 2) {
         if (rank_proces == 0) {
            index_actual = tamanys[0];
            for (i = 1; i < num_processos; i++) {
               // Dona error d'execucio  <-- REVISAR !!
               MPI_Issend(&valors[index_actual],tamanys[i],MPI_INT,i,tag,MPI_COMM_WORLD,&req);
               index_actual += tamanys[i];
            }
         }
         else {
            MPI_Recv(&buffer_proces[0],tamanys[rank_proces],MPI_INT,0,tag,MPI_COMM_WORLD,estat);
         }
      }
      
      //----------------------------------------
      // Algorisme d'ordenacio de subvectors...
      // El proces Host no necessita rebre el subvector donat que es ell qui el posseeix i el
      // distribueix als demes processos Kernel, per la qual cosa el proces Host treballara
      // la ordenacio sobre el vector 'valors'

      if (rank_proces != 0) {
         for (i = 0; i < tamanys[rank_proces] - 1; i++) {
            minim = buffer_proces[i + 1];
            min_index = i + 1;
            for (j = i + 2; j < tamanys[rank_proces]; j++) {
               if (buffer_proces[j] < minim) {
                  minim = buffer_proces[j];
                  min_index = j;
               }
            }
            if (buffer_proces[i] > minim) {
               buffer_proces[min_index] = buffer_proces[i];
               buffer_proces[i] = minim;
            }
         }
      }
      else {
         for (i = 0; i < tamanys[rank_proces] - 1; i++) {
            minim = valors[i + 1];
            min_index = i + 1;
            for (j = i + 2; j < tamanys[rank_proces]; j++) {
               if (valors[j] < minim) {
                  minim = valors[j];
                  min_index = j;
               }
            }
            if (valors[i] > minim) {
               valors[min_index] = valors[i];
               valors[i] = minim;
            }
         }
      }
      
      //--------------------------------------------
      
      // El proces Host reb els subvectors ordenats de tots els processos kernel i els fusiona
      // en el vector final ordenat aplicant l'algorisme merge-sort
      if (rank_proces == 0) {
         subvector[0] = valors;
         
         
         for (i = 1; i < num_processos; i++) {
            MPI_Recv(&subvector[i][0],tamanys[i],MPI_INT,i,tag,MPI_COMM_WORLD,estat);
         }
         resultat = merge_sort(&subvector[0],num_processos,tamanys);
      }
      // Els processos Kernel envien els subvectors ordenats al proces Host amb comunicacio sincrona
      else {
         MPI_Ssend(buffer_proces,tamanys[rank_proces],MPI_INT,0,tag,MPI_COMM_WORLD);
      }
         
      if (rank_proces == 0) {
         for (i=0;i<N;i++) {                   // fer-ho enviant el tam_particio a cada proces i fent la suma 
//printf("(%d - %d) ",sum,resultat[i]);fflush(stdout);
            if (i%100) {                       // del valor retornat per cada proces kernel en el proces host
               sum += resultat[i];
	       
            }
         }
      }
   
      // Alliberament del buffer d'enviament local per a comunicacio asincrona
      //tam = TAM_BUFFER;
      //MPI_Buffer_detach(buffer_enviaments,&tam);
      
      // Finalitzar MPI
      MPI_Finalize();



   }
   // Nomes hi ha un proces: execucio sequencial de l'algorisme d'ordenacio
   else 
   {
      for (i = 0; i < N - 1; i++) {
         minim = valors[i + 1];
         min_index = i + 1;
         for (j = i + 2; j < N; j++) {
            if (valors[j] < minim) {
               minim = valors[j];
               min_index = j;
            }
         }
         if (valors[i] > minim) {
            valors[min_index] = valors[i];
            valors[i] = minim;
         }
      }
      for (i = 0; i < N; i++) {
         if (i%100) { 
            sum += valors[i];
         }
      }
      // Finalitzar MPI
      MPI_Finalize();
   }
   if (rank_proces == 0) {
      sal=fopen("sec.sal","w");
      assert(sal!=NULL);
         
      fprintf(sal,"%f\n",sum);
      //for(i=0;i<N;i++) fprintf(sal,"%d\n",resultat[i]);
      close(sal);
   }
   
   return(0);

}


